Unit de26e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE33E_p, DE28EP_p, DE28ES_p, UTDE13_p;

procedure de26e(F :Proc_FE_DE; M :Integer; var JSTART :Integer;
                var YX :Array of Extended; var X :Extended; H :Extended;
                var DELTY :Array of Extended; var DF :Array of Extended;
                var RF :Array of Extended; var YP :Array of Extended;
                var RY :Array of Extended; var RFN :Array of Extended;
                var IERR :Integer);

implementation

procedure de26e(F :Proc_FE_DE; M :Integer; var JSTART :Integer;
                var YX :Array of Extended; var X :Extended; H :Extended;
                var DELTY :Array of Extended; var DF :Array of Extended;
                var RF :Array of Extended; var YP :Array of Extended;
                var RY :Array of Extended; var RFN :Array of Extended;
                var IERR :Integer);
var
I,K,K1 :Integer;
ALP :Extended;
BUL2 :Boolean;
RX :Array [0..4] of Extended;
const
C1 :Extended = 0.5e0;
C2 :Extended = 0.4166666666666667e0;
C3 :Extended = 0.375e0;
C4 :Extended = -0.02638888888888889e0;
IMAX :Integer = 6;
P :Extended = 0.01e0;
EPS :Extended = 0.0000001e0;
IORDER :Integer = 5;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
if ( JSTART >= 0 )
 then goto _3;
if ( IERR = 0 )
 then goto _1;
IERR := 0;
goto _5;
_1:
for K:=1 to 4 do
 begin
  K1 := K+1;
  for I:=1 to M do
   begin
    DF[(I-1)+(K-1)*M] := DF[(I-1)+(K-1)*M]-DF[(I-1)+(K1-1)*M];
_2:
   end;
 end;
goto _5;
_3:
_COM26D.elm2 := X;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_4:
 end;
IERR := 0;
if ( JSTART <> 0 )
 then goto _5;
F(X,YX,RF,M);
DE33E(F,M,IORDER,X,YX,H,DF,RX,RY,RFN,RF,DELTY,I);
goto _6;
_5:
if ( H = _COM26D.elm1 )
 then goto _6;
ALP := H/_COM26D.elm1;
DE28EP(M,IORDER,ALP,DF);
_6:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1]+DF[(I-1)+0*M]+DF[(I-1)+1*M]*C1+DF[(I-1)+2*M]*C2+DF[(I-1)+3*M]*C3;
  RF[I-1] := DF[(I-1)+0*M]+DF[(I-1)+1*M]+DF[(I-1)+2*M]+DF[(I-1)+3*M];
_7:
 end;
X := _COM26D.elm2+H;
for K:=1 to IMAX do
 begin
  BUL2 := True;
  for I:=1 to M do
   begin
    DELTY[I-1] := -RF[I-1]*C3;
_8:
   end;
  F(X,YX,RF,M);
  for I:=1 to M do
   begin
    RF[I-1] := RF[I-1]*H;
    DELTY[I-1] := DELTY[I-1]+RF[I-1]*C3;
    YX[I-1] := DELTY[I-1]+YX[I-1];
    if ( Abs(YX[I-1]) <= P ) 
     then goto _9;
    DELTY[I-1] := DELTY[I-1]/YX[I-1];
_9:
    if ( Abs(DELTY[I-1]) > EPS ) 
     then BUL2 := False;
_10:
   end;
  if ( BUL2 ) 
   then goto _13;
_11:
 end;
IERR := 65;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_12:
 end;
X := _COM26D.elm2;
goto _15;
_13:
DE28ES(M,IORDER,RF,DF,DELTY);
for I:=1 to M do
 begin
  DELTY[I-1] := DF[(I-1)+4*M]*C4;
  YX[I-1] := YX[I-1]+DELTY[I-1];
_14:
 end;
_15:
if ( IERR <> 0 ) 
 then UTDE13(IERR,26);
JSTART := 1;
_COM26D.elm1 := H;
end;

end.
